'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _dependenceManager = require('../dependence-manager');

var _dependenceManager2 = _interopRequireDefault(_dependenceManager);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import db from '../database';
var fixCompany = function fixCompany(name) {
  return name === 'From WeChat' ? '' : name;
};

var composeData = function composeData(item, fieldNames) {
  var data = (0, _assign2.default)({}, item);
  fieldNames.forEach(function (fieldName) {
    var key = '' + fieldName.slice(0, 1).toLowerCase() + fieldName.slice(1);
    data[key] = (0, _utils.getFieldValue)(item, fieldName);
  });

  return data;
};

// const fields = [
//   '++uid',
//   'id',
//   'eventId',
//   'replayId',
//   'qrcodeId',
//   'icon',
//   'name',
//   'company',
//   'createdDate',
//   'printDate'
// ];

// db.stores({
//   attendees: fields.join(', ')
// });

var Attendee = function () {
  function Attendee() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck3.default)(this, Attendee);

    (0, _assign2.default)(this, options);
  }

  (0, _createClass3.default)(Attendee, null, [{
    key: 'getListByEvent',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var eventUid = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : -1;
        var Provider, records, attendees;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                Provider = _dependenceManager2.default.get('AttendeeDataProvider');
                _context.next = 3;
                return Provider.getListByEvent(eventUid);

              case 3:
                records = _context.sent;
                attendees = records.map(function (record) {
                  return new Attendee(record);
                });
                return _context.abrupt('return', attendees);

              case 6:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getListByEvent() {
        return _ref.apply(this, arguments);
      }

      return getListByEvent;
    }()

    // static async deleteByEvent(eventId) {
    //   console.info('deleteByEvent', eventId);
    //   const keysToDelete = [];
    //   await db.instance.attendees
    //     .where('eventId')
    //     .equals(eventId)
    //     .each(i => keysToDelete.push(i.uid));

    //   console.info('deleteByEvent keys', keysToDelete);

    //   return db.instance.attendees.bulkDelete(keysToDelete);
    // }

  }, {
    key: 'filter',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(eventUid, keyword) {
        var items, lowerCaseKeyword, filteredItems;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                console.info('Attendee.filter', eventUid, keyword);
                _context2.next = 3;
                return Attendee.getListByEvent(eventUid);

              case 3:
                items = _context2.sent;
                lowerCaseKeyword = keyword.trim().toLowerCase();

                if (!(lowerCaseKeyword === '')) {
                  _context2.next = 7;
                  break;
                }

                return _context2.abrupt('return', items);

              case 7:
                filteredItems = items.filter(function (i) {
                  return i.name && i.name.toLowerCase().indexOf(lowerCaseKeyword) > -1 || i.company && i.company.toLowerCase().indexOf(lowerCaseKeyword) > -1;
                });
                return _context2.abrupt('return', filteredItems);

              case 9:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function filter(_x3, _x4) {
        return _ref2.apply(this, arguments);
      }

      return filter;
    }()
  }, {
    key: 'searchSalesforce',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(_ref3) {
        var event = _ref3.event,
            keyword = _ref3.keyword;

        var CAMPAIGN_MEMBER_OBJECT, CONTACT_OBJECT, LEAD_OBJECT, campaignMemberFields, contactFields, leadFields, template, mergeFields, limit, requests, Provider, _ref5, _ref5$compositeRespon, campaignMemberResult, contactResult, leadResult, campaignMembers, contacts, leads, items;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                CAMPAIGN_MEMBER_OBJECT = 'CampaignMember';
                CONTACT_OBJECT = 'Contact';
                LEAD_OBJECT = 'Lead';
                campaignMemberFields = ['Id', 'FirstName', 'LastName', 'Name', 'CompanyOrAccount', 'MobilePhone', 'Phone', 'Email', 'ContactId', 'LeadId', 'Contact.Account.Industry', 'Lead.Industry'];
                contactFields = ['Id', 'FirstName', 'LastName', 'Name', 'Account.Name', 'Account.Industry', 'MobilePhone', 'Phone', 'Email'];
                leadFields = ['Id', 'FirstName', 'LastName', 'Name', 'Company', 'Phone', 'Email', 'Industry'];

                if (!(event.nameBadgeTemplates.length > 0)) {
                  _context3.next = 20;
                  break;
                }

                template = event.getNameBadgeTemplate(event.nameBadgeTemplates[0]);

                if (!template) {
                  _context3.next = 20;
                  break;
                }

                mergeFields = JSON.parse(template.MergeFields__c);
                _context3.t0 = mergeFields.object;
                _context3.next = _context3.t0 === CAMPAIGN_MEMBER_OBJECT ? 13 : _context3.t0 === CONTACT_OBJECT ? 15 : _context3.t0 === LEAD_OBJECT ? 17 : 19;
                break;

              case 13:
                mergeFields.fields.forEach(function (field) {
                  if (!campaignMemberFields.includes(field)) {
                    campaignMemberFields.push(field);
                  }
                });

                return _context3.abrupt('break', 20);

              case 15:
                mergeFields.fields.forEach(function (field) {
                  if (!contactFields.includes(field)) {
                    contactFields.push(field);
                  }
                });

                return _context3.abrupt('break', 20);

              case 17:
                mergeFields.fields.forEach(function (field) {
                  if (!leadFields.includes(field)) {
                    leadFields.push(field);
                  }
                });

                return _context3.abrupt('break', 20);

              case 19:
                return _context3.abrupt('break', 20);

              case 20:
                limit = 20;
                requests = [{
                  type: 'query',
                  soql: ['select ', campaignMemberFields.join(', '), ' from ', CAMPAIGN_MEMBER_OBJECT, ' where CampaignId = \'', event.campaignId, '\' ', 'and (MobilePhone like \'%', keyword, '%\' ', 'or Phone like \'%', keyword, '%\' ', 'or FirstName like \'%', keyword, '%\' ', 'or LastName like \'%', keyword, '%\' ', 'or CompanyOrAccount like \'%', keyword, '%\' ', 'or Email like \'%', keyword, '%\') ', 'limit ', limit].join('')
                }, {
                  type: 'query',
                  soql: ['select ', contactFields.join(', '), ' from ', CONTACT_OBJECT, ' where MobilePhone like \'%', keyword, '%\' ', 'or Phone like \'%', keyword, '%\' ', 'or Name like \'%', keyword, '%\' ', 'or Account.Name like \'%', keyword, '%\' ', 'or Email like \'%', keyword, '%\' ', 'limit ', limit].join('')
                }, {
                  type: 'query',
                  soql: ['select ', leadFields.join(', '), ' from ', LEAD_OBJECT, ' where Phone like \'%', keyword, '%\' ', 'or Name like \'%', keyword, '%\' ', 'or Company like \'%', keyword, '%\' ', 'or Email like \'%', keyword, '%\' ', 'limit ', limit].join('')
                }];
                Provider = _dependenceManager2.default.get('SalesforceAPIProvider');
                _context3.next = 25;
                return Provider.composite(requests);

              case 25:
                _ref5 = _context3.sent;
                _ref5$compositeRespon = (0, _slicedToArray3.default)(_ref5.compositeResponse, 3);
                campaignMemberResult = _ref5$compositeRespon[0].body;
                contactResult = _ref5$compositeRespon[1].body;
                leadResult = _ref5$compositeRespon[2].body;
                campaignMembers = [];

                if (!campaignMemberResult.done) {
                  _context3.next = 35;
                  break;
                }

                campaignMembers = campaignMemberResult.records;
                _context3.next = 36;
                break;

              case 35:
                throw new Error(campaignMemberResult[0].message);

              case 36:
                contacts = [];

                if (!contactResult.done) {
                  _context3.next = 41;
                  break;
                }

                contacts = contactResult.records;
                _context3.next = 42;
                break;

              case 41:
                throw new Error(contactResult[0].message);

              case 42:
                leads = [];

                if (!leadResult.done) {
                  _context3.next = 47;
                  break;
                }

                leads = leadResult.records;
                _context3.next = 48;
                break;

              case 47:
                throw new Error(leadResult[0].message);

              case 48:
                items = [];

                campaignMembers.forEach(function (member) {
                  if (items.length >= limit) {
                    return;
                  }

                  var item = composeData(member, campaignMemberFields);
                  item.objectType = 'Campaign Member';
                  item.company = fixCompany(member.CompanyOrAccount);
                  if (member.ContactId) {
                    item.industry = (0, _utils.getFieldValue)(member, 'Contact.Account.Industry');
                  } else if (member.LeadId) {
                    item.industry = (0, _utils.getFieldValue)(member, 'Lead.Industry');
                  } else {
                    item.industry = 'Unknown';
                  }

                  items.push(item);
                });

                contacts.forEach(function (contact) {
                  if (items.length >= limit) {
                    return;
                  }

                  var index = items.findIndex(function (item) {
                    return item.contactId === contact.Id;
                  });
                  if (index > -1) {
                    return;
                  }

                  var item = composeData(contact, contactFields);
                  item.objectType = 'Contact';
                  item.company = fixCompany((0, _utils.getFieldValue)(contact, 'Account.Name'));
                  item.industry = (0, _utils.getFieldValue)(contact, 'Account.Industry');
                  items.push(item);
                });

                leads.forEach(function (lead) {
                  if (items.length >= limit) {
                    return;
                  }

                  var index = items.findIndex(function (item) {
                    return item.leadId === lead.Id;
                  });
                  if (index > -1) {
                    return;
                  }

                  var item = composeData(lead, leadFields);
                  item.objectType = 'Lead';
                  item.company = fixCompany(lead.Company);
                  items.push(item);
                });

                return _context3.abrupt('return', items);

              case 53:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function searchSalesforce(_x5) {
        return _ref4.apply(this, arguments);
      }

      return searchSalesforce;
    }()

    // static async findOne(eventId, id) {
    //   const conditions = {
    //     eventId,
    //     id
    //   };

    //   const attendee = await db.instance.attendees.where(conditions).first();
    //   console.info('findOne', attendee);

    //   return attendee ? new Attendee(attendee) : attendee;
    // }

  }, {
    key: 'createOrUpdate',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(values) {
        var Provider, existedUid;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                Provider = _dependenceManager2.default.get('AttendeeDataProvider');
                _context4.next = 3;
                return Provider.exsits({
                  eventUid: values.eventUid,
                  campaignMemberId: values.campaignMemberId
                });

              case 3:
                existedUid = _context4.sent;

                if (!existedUid) {
                  _context4.next = 6;
                  break;
                }

                return _context4.abrupt('return', Attendee.update(existedUid, values));

              case 6:
                return _context4.abrupt('return', Attendee.create(values));

              case 7:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function createOrUpdate(_x6) {
        return _ref6.apply(this, arguments);
      }

      return createOrUpdate;
    }()
  }, {
    key: 'create',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(values) {
        var duplicated, Provider, uid;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                duplicated = (0, _assign2.default)({}, values);

                duplicated.createdDate = new Date();
                duplicated.updatedDate = new Date();
                Provider = _dependenceManager2.default.get('AttendeeDataProvider');
                _context5.next = 6;
                return Provider.insert(duplicated);

              case 6:
                uid = _context5.sent;

                duplicated.uid = uid;

                return _context5.abrupt('return', new Attendee(duplicated));

              case 9:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function create(_x7) {
        return _ref7.apply(this, arguments);
      }

      return create;
    }()
  }, {
    key: 'update',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(uid, values) {
        var duplicated, Provider;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                duplicated = (0, _assign2.default)({}, values);

                duplicated.updatedDate = new Date();
                duplicated.uid = uid;
                Provider = _dependenceManager2.default.get('AttendeeDataProvider');
                _context6.next = 6;
                return Provider.update(duplicated);

              case 6:
                return _context6.abrupt('return', new Attendee(duplicated));

              case 7:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function update(_x8, _x9) {
        return _ref8.apply(this, arguments);
      }

      return update;
    }()

    // async update(values) {
    //   await db.instance.attendees.update(this.uid, values);
    //   this.replayId = values.replayId;
    //   this.qrcodeId = values.qrcodeId;
    //   this.printDate = values.printDate;
    //   this.photoURL = values.photoURL;
    //   this.name = values.name;
    //   this.company = values.company;

    //   return this;
    // }

  }]);
  return Attendee;
}();

exports.default = Attendee;